<?php
defined('ABSPATH') || exit;
global $current_user;
$_nonce = wp_create_nonce('rizhuti-v2-click-' . $current_user->ID);
$userPhone = ($user instanceof WP_User) ? get_the_author_meta('user_phone', $user->ID) : '';
?>


<div class="card mb-3 mb-lg-5">
    <div class="card-header">
        <h5 class="card-title"><?php echo esc_html__('个人基本信息','ripro-v2');?></h5>
    </div>
    <!-- Body -->
    <div class="card-body">
        <form id="post-form">
    
            <div class="row">
                <!-- 默认 上传 -->

                <div class="col-12">
                    <span class="btn avatarinfo">
                        <label for="addPic">
                        <img src="<?php echo get_avatar_url($current_user->ID);?>" height="50" class="mr-2">
                        <?php if (!_cao('disabled_up_ava')) { ?>
                            <a class="upload" data-toggle="tooltip" data-placement="right" title="<?php echo esc_html__('点击修改头像，请上传80x80尺寸的JPG/PNG头像，最大可上传80KB','ripro-v2');?>"><input type="file" name="addPic" id="addPic" accept=".jpg, .gif, .png" resetonclick="true" data-nonce="<?php echo $_nonce; ?>">
                            </a>
                        <?php } ?>
                        </label>
                    </span>
                </div>
                <div class="col-12">
                    <div class="form-group">
                    <h5 class="mb-1 text-white"><span style="color: #1a1a1a; margin-right: 16px; font-size: 12px;">您的用户组</span><a href="<?php echo get_user_page_url('vip');?>" title="<?php echo date('Y-m-d',_get_user_vip_endtime());?>到期"><?php echo _get_user_vip_type_badge($current_user->ID); ?></a></h5>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>登录账号：<?php echo $current_user->user_email;?>  <a href="https://soft.yuucn.com/user/bind" target="_blank" style="font-size: 10px;color: red;padding-left: 15px;">设置</a></label>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>昵称：<?php echo $current_user->display_name;?></label>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>注册时间：<?php echo $current_user->user_registered;?></label>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>注册IP地址：<?php echo $current_user->register_ip;?></label>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>本次登录：<?php echo $current_user->last_login_time;?></label>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label>近期登录IP：<?php echo $current_user->last_login_ip;?></label>
                    </div>
                </div>
                
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label><?php echo esc_html__('昵称','ripro-v2');?></label>
                        <input class="form-control" name="nickname" type="text" value="<?php echo $current_user->display_name;?>"></input>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label><?php echo esc_html__('联系QQ','ripro-v2');?></label>
                        <input class="form-control" name="qq" type="text" value="<?php echo get_user_meta($current_user->ID, 'qq',1 );?>" ></input>
                    </div>
                </div>
                <div class="col-xs-12 col-md-6">
                    <div class="form-group">
                        <label><?php echo esc_html__('电话号码/手机号码','ripro-v2');?></label>
                        <input type="text" class="form-control" name="phone" value="<?php echo get_user_meta($current_user->ID, 'phone',true )?>">
                    </div>
                </div>
                <div class="col-12">
                    <div class="form-group">
                        <label><?php echo esc_html__('备注','ripro-v2');?></label>
                        <textarea name="description" rows="4" class="form-control pl-3" placeholder="备注仅仅用户自己可以看到"><?php echo get_user_meta($current_user->ID, 'description',true )?></textarea>
                    </div>
                </div>

                
            </div>
            
        </form>
        </div>

    <!-- End Body -->
    <!-- Footer -->
    <div class="card-footer d-flex justify-content-end">
        <button id="save-userinfo" type="button" class="btn btn-dark" data-nonce="<?php echo $_nonce; ?>">保存个人信息</button>
    </div>
    <!-- End Footer -->
    <hr>
      <ul class="small text-muted mx-2">
        个人资料说明：
        <li>我们实行国际通用标准保护您的个人隐私，热烈祝贺本站注册用户突破5万人，即日起，注册用户将赠送365天VIP，享受VIP特权。</li>
        <li>2019年2月开始，在我们网站发表评论必须通过人机验证，实名认证或绑定手机号，验证通过才能发布评论，手机号码暂时不支持自助修改。</li>
        <li>第三方账号登录本站，登录用户名为随机分配，用户可以申请修改一次，申请需要联系客服协助修改。</li>
        <li>账户注销：请使用<?php echo $current_user->user_email;?>发送邮件至 service@yuucn.com 邮件模板如下，一字不差，建议复制以下文本，我们将在24小时内注销您的账户。</li>
        <br>邮件主题：注销账号<br>
        邮件正文：本人在电脑学习网注册ID为<?php echo $current_user->ID;?>，因个人原因不再使用，自愿放弃ID为<?php echo $current_user->ID;?>名下所有虚拟资产，申请注销。

      </ul>
</div>

<!-- JS脚本 -->
<script type="text/javascript">
jQuery(function() {
    'use strict';
    // addPic
    $("#addPic").change(function(e) {

        var formData = new FormData();

        formData.append("nonce",$(this).data("nonce"));
        formData.append("action", "update_avatar_photo");
        formData.append("file", e.currentTarget.files[0]);

        $.ajax({
            url:riprov2.admin_url,
            dataType:'json',
            type:'POST',
            async: false,
            data: formData,
            processData : false, // 使数据不做处理
            contentType : false, // 不要设置Content-Type请求头
            success: function(result){
                if (result.status == 1) {
                    ripro_v2_toast_msg('success',result.msg,function(){location.reload()})
                }else{
                    ripro_v2_toast_msg('info',result.msg)
                }
            },
            error:function(response){
                ripro_v2_toast_msg('info','error')
            }
        });

    })


    //保存个人信息
    $("#save-userinfo").on("click", function(event) {
        event.preventDefault();
        var site_js_text = {
            'txt1': '<?php echo esc_html__('保存中...','ripro-v2')?>',
        };
        var _this = $(this);
        var deft = _this.html();
        var toast_type = "success";
        var d = {};
        var t = $('#post-form').serializeArray();
        $.each(t, function() {
          d[this.name] = this.value;
        });
        d['action'] = "seav_userinfo";
        d['nonce'] = _this.data("nonce");
        rizhuti_v2_ajax(d,function(before) {
            _this.html(iconspin+site_js_text.txt1)
        },function(result) {
            if (result.status == 0) {
                toast_type = "info";
            }
            ripro_v2_toast_msg(toast_type,result.msg,function(){location.reload()})
        },function(complete) {
            _this.html(deft)
        });

    });
    
});
</script>
