<?php
global $post, $current_user;
$user_id     = $current_user->ID; //用户ID
$post_id     = $post->ID; //文章ID
$click_nonce = wp_create_nonce('rizhuti_click_' . $post_id);

if (!is_single() || is_close_site_shop()) {
    return;
}

//是否购买
$RiClass = new RiClass($post_id,$user_id);
$IS_PAID = $RiClass->is_pay_post();

//按钮组件
$the_user_type = _get_user_vip_type($user_id);
$the_post_price = get_post_price($post_id,$the_user_type);


$thumbnail = _get_post_thumbnail_url($post,'thumbnail');

?>



<div class="hero-shop-warp">
    <div class="container-lg">
        <div class="row">
            <div class="col-lg-4 img-box">
                <img class="lazyload" data-src="<?php echo $thumbnail;?>" src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" alt="<?php echo get_the_title();?>" />
                <noscript><img src="<?php echo $thumbnail;?>" alt="<?php echo get_the_title();?>" /></noscript>
            </div>
            <div class="col-lg-8 info-box">
                <header class="entry-header">
                <h1 class="entry-title"><?php echo get_the_title();?></h1></header>
                <div class="row">
                    <div class="col-lg-6 col-12">
                        <?php the_post_shop_priceo_options($post_id);?>
                    </div>
                    <div class="col-lg-6 col-12">
                        <?php 
                        $cao_info = array();
                        if ( $cao_demourl = get_post_meta($post_id, 'cao_demourl', true) ) {
                            $cao_info[] = array('title'=>esc_html__('演示地址','ripro-v2'),'desc'=>'<a target="_blank" rel="nofollow noopener noreferrer" href="' . $cao_demourl . '" class="badge badge-light-lighten"><i class="fas fa-link"></i> ' . esc_html__('点击查看','ripro-v2') . '</a>');
                        }
                        if ( $cao_expire_day = get_post_shop_expire_day($post_id) ) {
                            $cao_expire_day = ($cao_expire_day==9999) ? esc_html__('购买后永久有效','ripro-v2') : sprintf(__('购买后 %s 天内有效','ripro-v2'),$cao_expire_day) ;
                            $cao_info[] = array('title'=>esc_html__('有效期','ripro-v2'),'desc'=>$cao_expire_day);
                        }
                        if ( true ) {
                            $cao_info[] = array('title'=>esc_html__('最近更新','ripro-v2'),'desc'=>get_the_modified_time('Y年m月d日'));
                        }
                        echo '<ul class="down-info">';
                        foreach ($cao_info as $key => $value) {
                            echo '<li><p class="data-label">' . $value['title'] . '：' . $value['desc'] . '</p></li>';
                        }
                        echo '</ul>';
                        ?>
                    </div>
                </div>
                <!--购买按钮开始-->
                <div class="col-lg-8 info-box" style="padding-top: 10px;">
                
                <?php 
                
            $the_user_type  = _get_user_vip_type($user_id);
            $the_post_price = get_post_price($post_id, $the_user_type);

            if ($IS_PAID == 0) {
                # 未购买... is_site_nologin_pay
                if ($the_user_type == 'nov' && $the_post_price == -1) {
                    echo '<button type="button" class="btn btn-block btn-danger mb-3" disabled>' . esc_html__('暂无购买权限', 'ripro-v2') . '</button>';
                } elseif (empty($user_id) && !is_site_nologin_pay()) {
                    echo '<button type="button" class="btn btn-block btn-primary mb-3 login-btn">' . esc_html__('登录后下载', 'ripro-v2') . '</button>';
                } else {
                    echo '<button type="button" class="btn btn-block btn-primary mb-3 click-pay-post" style="background-color:red;" data-postid="' . $post_id . '" data-nonce="' . $click_nonce . '" data-price="' . $the_post_price . '"><i class="fa fa-shopping-cart" ></i>  ' . get_shop_paybtn_txt() . '</button>  <button style="background-color:#ff8400" class="newShop_DiyButton" href="/qq/" target="_blank"><i class="fa fa-qq"></i>   客服QQ</button>  ';
                }
            } elseif ($IS_PAID == 3) {
                # 免费资源...
                if (empty($user_id) && !is_site_nologin_pay()) {
                    echo '<button type="button" class="btn btn-block btn-primary mb-3 login-btn">' . esc_html__('登录后下载', 'ripro-v2') . '</button>';
                } else {
                    the_post_shop_downurl_btns($post_id, $click_nonce);
                }
            } elseif ($IS_PAID > 0) {
                # 已购买...
                the_post_shop_downurl_btns($post_id, $click_nonce);
            }
                ?>
                </div>
                <!--购买按钮结束-->
            </div>
        </div>
    </div>
</div>
